/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Semaphore.xs. Do not edit this file, edit Semaphore.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Semaphore.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

#include <unistd.h>     /* _POSIX, _SC_* */

#if !defined(_POSIX_SEMAPHORES)
#  error "POSIX::RT::Semaphore requires _POSIX_SEMAPHORES support."
#endif

#include <semaphore.h>
#include <limits.h>     /* _POSIX_SEM_* */
#include <errno.h>      /* ENOSYS */

#ifdef HAVE_SEM_TIMEDWAIT
#  include <time.h>
#endif


#ifdef HAS_MMAP
#  include <sys/mman.h>
#  if defined(MAP_ANON) && !defined(MAP_ANONYMOUS)
#    define MAP_ANONYMOUS     MAP_ANON
#  endif
#  ifndef MAP_ANONYMOUS
#    include <fcntl.h> /* open(..., O_RDWR) */
#  endif
#  ifndef MAP_HASSEMAPHORE
#    define MAP_HASSEMAPHORE  0
#  endif
#  ifndef MAP_FAILED
#    define MAP_FAILED        ((void *)-1)
#  endif
#endif



typedef int SysRet;

typedef struct PSem_C {
  sem_t* sem;
  char * name;
} * POSIX__RT__Semaphore___base;
typedef POSIX__RT__Semaphore___base POSIX__RT__Semaphore__Named;
typedef POSIX__RT__Semaphore___base POSIX__RT__Semaphore__Unnamed;

/* _alloc_sem()
 * 
 * Return a new sem_t in shared memory (maybe), or NULL (_not_ SEM_FAILED)
 * on failure.
 */
static sem_t *
_alloc_sem(void) {
	sem_t *sem = NULL;
#ifdef HAS_MMAP
	int fd = -1;
	int prot_flags = PROT_READ|PROT_WRITE;
	int map_flags = MAP_SHARED|MAP_HASSEMAPHORE;

#  ifdef MAP_ANONYMOUS
	map_flags |= MAP_ANONYMOUS;
	sem = (sem_t *)mmap(NULL, sizeof(sem_t), prot_flags, map_flags, fd, 0);
#  else
	if ((fd = open("/dev/zero", O_RDWR)) != -1) {
		sem = (sem_t *)mmap(NULL, sizeof(sem_t), prot_flags, map_flags, fd, 0);
		close(fd);
	}
#  endif /* MAP_ANONYMOUS */
#else
	Newz(0, sem, 1, sem_t);
#endif /* HAS_MMAP */

	return sem;
}

/* _dealloc_sem
 *
 * Free a sem_t we allocated.
 */
static void
_dealloc_sem(sem_t *sem)
{
#ifdef HAS_MMAP
	munmap((void *)sem, sizeof(sem_t));
#else
	Safefree(sem);
#endif
}

static int
function_not_implemented(void)
{
  errno = ENOSYS;
  return -1;
}

#define sem_valid(sem)     ((sem) && (sem) != SEM_FAILED)

#define PRECOND_valid_psem(fname, psem)                   \
  do {                                                    \
    if (!psem || !sem_valid(psem->sem))                   \
        croak(fname "() method called on invalid psem");  \
  } while (0)


#line 117 "Semaphore.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 261 "Semaphore.c"

XS_EUPXS(XS_POSIX__RT__Semaphore_unlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore_unlink)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg = \"POSIX::RT::Semaphore\", path");
    {
	char*	pkg;
	char*	path = (char *)SvPV_nolen(ST(1))
;
	SysRet	RETVAL;

	if (items < 1)
	    pkg = "POSIX::RT::Semaphore";
	else {
	    pkg = (char *)SvPV_nolen(ST(0))
;
	}
#line 154 "Semaphore.xs"
#ifdef HAVE_SEM_UNLINK
	RETVAL = sem_unlink(path);
#else
	RETVAL = function_not_implemented();
#endif

#line 288 "Semaphore.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (RETVAL != -1) {
		if (RETVAL == 0)
		    sv_setpvn(RETVALSV, "0 but true", 10);
		else
		    sv_setiv(RETVALSV, (IV)RETVAL);
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Semaphore___base_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore___base_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	POSIX__RT__Semaphore___base	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(POSIX__RT__Semaphore___base,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"POSIX::RT::Semaphore::_base::DESTROY",
			"self")
;
#line 172 "Semaphore.xs"
	if (self->name) {
		if (sem_valid(self->sem))
			(void)sem_close(self->sem);
		Safefree(self->name);
	} else {
		if (sem_valid(self->sem))
			_dealloc_sem(self->sem);
	}
	Safefree(self);
#line 333 "Semaphore.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_POSIX__RT__Semaphore___base_wait); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore___base_wait)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	POSIX__RT__Semaphore___base	self;
	SysRet	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "POSIX::RT::Semaphore::_base")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(POSIX__RT__Semaphore___base,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"POSIX::RT::Semaphore::_base::wait",
			"self", "POSIX::RT::Semaphore::_base")
;
#line 187 "Semaphore.xs"
	PRECOND_valid_psem("wait", self);
	RETVAL = sem_wait(self->sem);

#line 362 "Semaphore.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (RETVAL != -1) {
		if (RETVAL == 0)
		    sv_setpvn(RETVALSV, "0 but true", 10);
		else
		    sv_setiv(RETVALSV, (IV)RETVAL);
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Semaphore___base_trywait); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore___base_trywait)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	POSIX__RT__Semaphore___base	self;
	SysRet	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "POSIX::RT::Semaphore::_base")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(POSIX__RT__Semaphore___base,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"POSIX::RT::Semaphore::_base::trywait",
			"self", "POSIX::RT::Semaphore::_base")
;
#line 198 "Semaphore.xs"
	PRECOND_valid_psem("trywait", self);
	RETVAL = sem_trywait(self->sem);

#line 402 "Semaphore.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (RETVAL != -1) {
		if (RETVAL == 0)
		    sv_setpvn(RETVALSV, "0 but true", 10);
		else
		    sv_setiv(RETVALSV, (IV)RETVAL);
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Semaphore___base_timedwait); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore___base_timedwait)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, timeout");
    {
	POSIX__RT__Semaphore___base	self;
	NV	timeout = (NV)SvNV(ST(1))
;
#line 210 "Semaphore.xs"
#ifdef HAVE_SEM_TIMEDWAIT
	struct timespec ts;
#endif

#line 434 "Semaphore.c"
	SysRet	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "POSIX::RT::Semaphore::_base")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(POSIX__RT__Semaphore___base,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"POSIX::RT::Semaphore::_base::timedwait",
			"self", "POSIX::RT::Semaphore::_base")
;
#line 215 "Semaphore.xs"
	PRECOND_valid_psem("timedwait", self);
#ifdef HAVE_SEM_TIMEDWAIT
	if (timeout < 0.0)
		timeout = 0.0;
	ts.tv_sec  = (long)timeout;
	timeout -= (NV)ts.tv_sec;
	ts.tv_nsec = (long)(timeout * 1000000000.0);
	RETVAL = sem_timedwait(self->sem, (const struct timespec *)&ts);
#else
	RETVAL = function_not_implemented();
#endif

#line 459 "Semaphore.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (RETVAL != -1) {
		if (RETVAL == 0)
		    sv_setpvn(RETVALSV, "0 but true", 10);
		else
		    sv_setiv(RETVALSV, (IV)RETVAL);
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Semaphore___base_post); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore___base_post)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	POSIX__RT__Semaphore___base	self;
	SysRet	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "POSIX::RT::Semaphore::_base")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(POSIX__RT__Semaphore___base,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"POSIX::RT::Semaphore::_base::post",
			"self", "POSIX::RT::Semaphore::_base")
;
#line 235 "Semaphore.xs"
	PRECOND_valid_psem("post", self);
	RETVAL = sem_post(self->sem);

#line 499 "Semaphore.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (RETVAL != -1) {
		if (RETVAL == 0)
		    sv_setpvn(RETVALSV, "0 but true", 10);
		else
		    sv_setiv(RETVALSV, (IV)RETVAL);
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Semaphore___base_getvalue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore___base_getvalue)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	POSIX__RT__Semaphore___base	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "POSIX::RT::Semaphore::_base")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(POSIX__RT__Semaphore___base,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"POSIX::RT::Semaphore::_base::getvalue",
			"self", "POSIX::RT::Semaphore::_base")
;
#line 247 "Semaphore.xs"
	PRECOND_valid_psem("getvalue", self);
	if (sem_getvalue(self->sem, &RETVAL) != 0) {
		XSRETURN_UNDEF;
	}

#line 542 "Semaphore.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Semaphore___base_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore___base_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	POSIX__RT__Semaphore___base	self;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "POSIX::RT::Semaphore::_base")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(POSIX__RT__Semaphore___base,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"POSIX::RT::Semaphore::_base::name",
			"self", "POSIX::RT::Semaphore::_base")
;
#line 261 "Semaphore.xs"
	PRECOND_valid_psem("name", self);
	RETVAL = self->name;

#line 573 "Semaphore.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Semaphore__Unnamed_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore__Unnamed_init)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 3)
       croak_xs_usage(cv,  "pkg = \"POSIX::RT::Semaphore::Unnamed\", pshared = 0, value = 1");
    {
	char*	pkg;
	int	pshared;
	unsigned	value;
	POSIX__RT__Semaphore__Unnamed	RETVAL;

	if (items < 1)
	    pkg = "POSIX::RT::Semaphore::Unnamed";
	else {
	    pkg = (char *)SvPV_nolen(ST(0))
;
	}

	if (items < 2)
	    pshared = 0;
	else {
	    pshared = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    value = 1;
	else {
	    value = (unsigned)SvUV(ST(2))
;
	}
#line 278 "Semaphore.xs"
	Newz(0, RETVAL, 1, struct PSem_C);
	RETVAL->sem = _alloc_sem();
	if (NULL == RETVAL->sem) {
		Safefree(RETVAL);
		croak("sem_init: failed to allocate semaphore");
	}
	if (sem_init(RETVAL->sem, pshared, value) == -1) {
		_dealloc_sem(RETVAL->sem);
		Safefree(RETVAL);
		RETVAL = NULL;
	}

#line 625 "Semaphore.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "POSIX::RT::Semaphore::Unnamed", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Semaphore__Unnamed_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore__Unnamed_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	POSIX__RT__Semaphore__Unnamed	self;
	SysRet	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "POSIX::RT::Semaphore::Unnamed")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(POSIX__RT__Semaphore__Unnamed,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"POSIX::RT::Semaphore::Unnamed::destroy",
			"self", "POSIX::RT::Semaphore::Unnamed")
;
#line 299 "Semaphore.xs"
	PRECOND_valid_psem("destroy", self);
	if (0 == (RETVAL = sem_destroy(self->sem))) {
		_dealloc_sem(self->sem);
		self->sem = NULL;
	}

#line 663 "Semaphore.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (RETVAL != -1) {
		if (RETVAL == 0)
		    sv_setpvn(RETVALSV, "0 but true", 10);
		else
		    sv_setiv(RETVALSV, (IV)RETVAL);
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Semaphore__Named_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore__Named_open)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 5)
       croak_xs_usage(cv,  "pkg = \"POSIX::RT::Semaphore::Named\", name, flags = 0, mode = 0666, value = 1");
    {
	char*	pkg;
	char*	name = (char *)SvPV_nolen(ST(1))
;
	int	flags;
	Mode_t	mode;
	unsigned	value;
#line 321 "Semaphore.xs"
	sem_t*              sem;

#line 696 "Semaphore.c"
	POSIX__RT__Semaphore__Named	RETVAL;

	if (items < 1)
	    pkg = "POSIX::RT::Semaphore::Named";
	else {
	    pkg = (char *)SvPV_nolen(ST(0))
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    mode = 0666;
	else {
	    mode = (Mode_t)SvNV(ST(3))
;
	}

	if (items < 5)
	    value = 1;
	else {
	    value = (unsigned)SvUV(ST(4))
;
	}
#line 324 "Semaphore.xs"
	sem = sem_open(name, flags, mode, value);
	if (SEM_FAILED == sem) {
		XSRETURN_UNDEF;
	}

	Newz(0, RETVAL, 1, struct PSem_C);
	RETVAL->sem = sem;
	RETVAL->name = savepv(name);

#line 736 "Semaphore.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "POSIX::RT::Semaphore::Named", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_POSIX__RT__Semaphore__Named_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_POSIX__RT__Semaphore__Named_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	POSIX__RT__Semaphore__Named	self;
	SysRet	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "POSIX::RT::Semaphore::Named")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(POSIX__RT__Semaphore__Named,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"POSIX::RT::Semaphore::Named::close",
			"self", "POSIX::RT::Semaphore::Named")
;
#line 342 "Semaphore.xs"
	PRECOND_valid_psem("close", self);
	RETVAL = sem_close(self->sem);
	self->sem = NULL;

#line 772 "Semaphore.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    if (RETVAL != -1) {
		if (RETVAL == 0)
		    sv_setpvn(RETVALSV, "0 but true", 10);
		else
		    sv_setiv(RETVALSV, (IV)RETVAL);
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_POSIX__RT__Semaphore); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_POSIX__RT__Semaphore)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("POSIX::RT::Semaphore::unlink", XS_POSIX__RT__Semaphore_unlink);
        newXS_deffile("POSIX::RT::Semaphore::_base::DESTROY", XS_POSIX__RT__Semaphore___base_DESTROY);
        newXS_deffile("POSIX::RT::Semaphore::_base::wait", XS_POSIX__RT__Semaphore___base_wait);
        newXS_deffile("POSIX::RT::Semaphore::_base::trywait", XS_POSIX__RT__Semaphore___base_trywait);
        newXS_deffile("POSIX::RT::Semaphore::_base::timedwait", XS_POSIX__RT__Semaphore___base_timedwait);
        newXS_deffile("POSIX::RT::Semaphore::_base::post", XS_POSIX__RT__Semaphore___base_post);
        newXS_deffile("POSIX::RT::Semaphore::_base::getvalue", XS_POSIX__RT__Semaphore___base_getvalue);
        newXS_deffile("POSIX::RT::Semaphore::_base::name", XS_POSIX__RT__Semaphore___base_name);
        newXS_deffile("POSIX::RT::Semaphore::Unnamed::init", XS_POSIX__RT__Semaphore__Unnamed_init);
        newXS_deffile("POSIX::RT::Semaphore::Unnamed::destroy", XS_POSIX__RT__Semaphore__Unnamed_destroy);
        newXS_deffile("POSIX::RT::Semaphore::Named::open", XS_POSIX__RT__Semaphore__Named_open);
        newXS_deffile("POSIX::RT::Semaphore::Named::close", XS_POSIX__RT__Semaphore__Named_close);

    /* Initialisation Section */

#line 111 "Semaphore.xs"
{
	char * const pkgs[] = {
		"POSIX::RT::Semaphore::Named::ISA",
		"POSIX::RT::Semaphore::Unnamed::ISA",
	};
	HV *stash;
	int i;

	for (i = 0; i < sizeof(pkgs)/sizeof(*pkgs); i++) {
		AV *isa;
		isa = get_av(pkgs[i], TRUE);
		av_push(isa, newSVpv("POSIX::RT::Semaphore::_base", 0));
	}

	stash = gv_stashpvn("POSIX::RT::Semaphore", 20, TRUE);

	newCONSTSUB(stash, "SIZEOF_SEM_T", newSViv(sizeof(sem_t)));
#ifdef _POSIX_SEM_VALUE_MAX
	newCONSTSUB(stash, "SEM_VALUE_MAX", newSViv(_POSIX_SEM_VALUE_MAX));
#endif
#ifdef _SC_SEM_VALUE_MAX
	newCONSTSUB(stash, "_SC_SEM_VALUE_MAX", newSViv(_POSIX_SEM_VALUE_MAX));
#endif
#ifdef _POSIX_SEM_NSEMS_MAX
	newCONSTSUB(stash, "SEM_NSEMS_MAX", newSViv(_POSIX_SEM_NSEMS_MAX));
#endif
#ifdef _SC_SEM_NSEMS_MAX
	newCONSTSUB(stash, "_SC_SEM_NSEMS_MAX", newSViv(_POSIX_SEM_NSEMS_MAX));
#endif
#ifdef SEM_NAME_LEN
	newCONSTSUB(stash, "SEM_NAME_LEN", newSViv(SEM_NAME_LEN));
#endif
#ifdef SEM_NAME_MAX
	newCONSTSUB(stash, "SEM_NAME_MAX", newSViv(SEM_NAME_MAX));
#endif
}

#line 869 "Semaphore.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

